<?php


defined('_JEXEC') or die('Restricted access');



class JBCartElementPaymentEasypay extends JBCartElementPayment

{



    /**

     * @var string

     */

    private $_realUrl = 'https://ssl.easypay.by/weborder/?EP_Module=JBZoo_2.2.x';

    /**

     * Redirect to payment action

     * @return null|string

     */

    public function getRedirectUrl()
    {
        $order       = $this->getOrder();
        $merchantUrl = $this->_realUrl;
        $successUrl  = $this->_jbrouter->payment('success') . '&EP_OrderNo=' . $this->getOrderId();
        $failUrl  = $this->_jbrouter->payment('fail') . '&EP_OrderNo=' . $this->getOrderId();
        $callbackUrl  = $this->_jbrouter->payment('callback');
        $payCurrency = $this->getDefaultCurrency();
        $orderAmount = $this->_order->val($this->getOrderSumm(), $order->getCurrency());
        $orderAmountVal = round($orderAmount->val(), 2);
        $EP_Hash = md5 ($this->config->get('ep_merno') . $this->config->get('webkey') . $order->id . $orderAmountVal);
        $fields = array(
            'EP_MerNo'        => $this->config->get('ep_merno'),
            'EP_Expires'      => $this->config->get('ep_expires'),
            'EP_URL_Type'     => 'get',
            'EP_Encoding'     => 'utf-8',
            'EP_Hash'         => $EP_Hash,
            'EP_OrderNo'      => $order->id,
            'EP_Sum'          => $orderAmountVal,
            'EP_Success_URL'  => $successUrl,
            'EP_Cancel_URL'   => $failUrl,
            'EP_OrderInfo'    => $this->getOrderDescription(),
        );

        return $merchantUrl . '?' . $this->_jbrouter->query($fields);
    }
	
    /**

     * Detect order id from merchant's robot request

     * @return int|JBCartValue

     */

    public function getRequestOrderId()

    {
        $task = $this->app->jbrequest->get('task');
        if ($task == 'paymentSuccess' || $task == 'paymentFail') {
            return $this->app->jbrequest->get('EP_OrderNo');
        }
        if ($task == 'paymentCallback') {
         return $this->app->jbrequest->get('order_mer_code');
        }
    }
    /**

     * Detect order id from merchant's robot request

     * @return int|JBCartValue

     */

    public function getRequestOrderSum()

    {
        $order       = $this->getOrder();
        $orderAmount = $this->_order->val($this->app->jbrequest->get('sum'), $order->getCurrency());
        return $orderAmount;
    }

    public function renderResponse()
    {
        header("HTTP/1.1 200 OK");
        jexit('OK | the notice is processed');
    }

    public function isValid($params = array())
    {
        $order_mer_code = $this->app->jbrequest->get('order_mer_code');
        $sum = $this->app->jbrequest->get('sum');
        $mer_no = $this->app->jbrequest->get('mer_no');
        $card = $this->app->jbrequest->get('card');
        $purch_date = $this->app->jbrequest->get('purch_date');
        $notify_signature = $this->app->jbrequest->get('notify_signature');
        $webkey = $this->config->get('webkey');
        $hash = md5 ($order_mer_code . $sum . $mer_no . $card . $purch_date . $web_key);
        if ($hash === $notify_signature) {
            return true;
        }
        return false;
    }

}